__doc__ = """
Persian transliteration hooks.

conforms to https://www.loc.gov/catdir/cpso/romanization/persian.pdf
"""

from logging import getLogger

from scriptshifter.exceptions import CONT


logger = getLogger(__name__)


def s2r_begin_input_token(ctx):
    """
    Apply special substitution rules according to ALA-LC spec.
    """
    # logger.debug(f"Looking up token: {ctx.src[ctx.cur]}")

    # TODO rule 4c: hamzah in iz̤āfah
    # TODO rule 4d: hamzah as indefinite article

    # Rule #7: shaddah
    if ctx.src[ctx.cur] == "\u0651":
        logger.debug("Applying rule #7c: shaddah.")
        last_char = ctx.src[ctx.cur - 1]
        if last_char == "\u0648":
            ctx.dest_ls[-1] = "ūv"
        elif last_char == "\u06CC":
            ctx.dest_ls[-1] = "īy"
        else:
            ctx.dest_ls.append(ctx.dest_ls[-1][-1])
        ctx.cur += 1
        return CONT

    # TODO Rule 8: iz̤āfah (probably in a different hook—needs a vocabulary).

    # TODO Rule 9a: needs affix vocabulary.

